import processing.video.*;
import java.util.Date;

Movie video;  
int timeDelay, lastTime, videoSliceX, drawPositionX, videoSliceY, drawPositionY;
long timestamp1, timestamp2;
boolean afficherVideo, sens;
Date d;
PImage img;

String myDate()
{
  int minutes;
  String arrondi;

  d = new Date();
  timestamp1 = d.getTime();
  
  minutes = minute();
  
  if(minutes <= 10) // 0 <= minutes <= 10 : h - 1 et 45
  {
    timestamp1 -= 3600000;
    arrondi = "45";
  }
  else if(minutes <= 25) // 10 < minutes <= 25 : 00
  {
    arrondi = "00";
  }
  else if(minutes <= 40) // 25 < minutes <= 40 : 15
  {
    arrondi = "15";
  }
  else if(minutes <= 55) // 40 < minutes <= 55 : 30
  {
    arrondi = "30";
  }
  else // 55 < minutes <= 60 : 45
  {
    arrondi = "45";
  }
   
  String date = new java.text.SimpleDateFormat("yyyyMMdd_HH" + arrondi).format(timestamp1);

  if(minutes <= 10)
  {
    timestamp1 += 3600000;
  }
  
  return date;
} 

void setup()
{  
  size(640, 480);

  timeDelay = 10000;
  lastTime = millis();
  img = loadImage("presentation.png");

  String url = "http://filmsgieat.viewsurf.com/autoroutestrafic02/Icade-cam1-320x240_h264/autoroutestrafic02_" + myDate() + ".mp4";
  
  video = new Movie(this, url);  
  video.loop();
  
  if(video.available())
  {
     println(url);
  }
  else
  {
    url = "horsconnexion.mp4";
    println(url);
    video = new Movie(this, url);
    video.loop();
  }

  afficherVideo = true;
  sens = true;
}

void movieEvent(Movie video)
{
  video.read();
}

void mouseClicked()
{ 
  image(video, 0, 0, width, height);
  
  videoSliceX = mouseX;
  drawPositionX = mouseX;
  videoSliceY = mouseY;
  drawPositionY = mouseY;
  
  afficherVideo = false;
}

void keyPressed()
{
  if(key == 'v')
  {
    afficherVideo = true;
  }
  else if(key == 'a')
  {
    timeDelay = 5000;
    lastTime = millis();
    afficherVideo = true;
  }
  else if(keyCode == DOWN)
  {
    image(video, 0, 0, width, height);    
    sens = false;
  }
  else if(keyCode == RIGHT)
  {
    image(video, 0, 0, width, height);
    sens = true;
  }
}

void draw()
{
  if((millis() - lastTime) <= timeDelay)
  {
    image(img, 0, 0);
  }
  else
  {  
    d = new Date();
    timestamp2 = d.getTime();
    
    if((timestamp2 - timestamp1) > 3600000)
    {
      setup(); // à chaque nouvelle heure, on charge une nouvelle vidéo
    }
    
    if(afficherVideo)
    {
      image(video, 0, 0, width, height);
    }
    else
    {
      video.loadPixels();
     
      loadPixels();
      
      if(sens == true)
      {
        for(int y = 0; y < video.height; y++)
        {
          int setPixelIndex = y*width + drawPositionX;
          int getPixelIndex = y*video.width  + videoSliceX;
          pixels[setPixelIndex] = video.pixels[getPixelIndex];
        }
        
        drawPositionX++;
      
        if(drawPositionX > video.width - 1)
        {
          drawPositionX = 0;
        }
      }
      else
      {
        for(int x = 0; x < video.width; x++)
        {
          int setPixelIndex = x + (width*drawPositionY);
          int getPixelIndex = x + (width*videoSliceY);
          pixels[setPixelIndex] = video.pixels[getPixelIndex];
        }
        
        drawPositionY++;
      
        if(drawPositionY > video.height - 1)
        {
          drawPositionY = 0;
        }
      }
      
      updatePixels();
    }
  }
}
